#include "Sequence.h"
#include "Build-IMM.h"

#include  <ctype.h>
#include  "Tree.h"
#include "vector.h"

int Model_Depth=6;
bool Reverse_Complement =false;
double lambda =0;


int main(int argc, char * argv []){

	Process_Options (argc, argv);
	Sequence seq (stdin);

//	cout<<seq._seq<<endl; 
//	cout <<seq._seq<<endl;

	Tree t(Model_Depth, lambda);
	t.BuildTree(seq._indexedseq, seq._seq.length());
	if(Reverse_Complement){
		seq.Reverse_Complement();
		t.BuildTree(seq._indexedseq, seq._seq.length());
	}
	while(seq.Next_Seq()){
		t.BuildTree(seq._indexedseq, seq._seq.length());
	        if(Reverse_Complement){
        	        seq.Reverse_Complement();
                	t.BuildTree(seq._indexedseq, seq._seq.length());
	        }
	}
//	t.Print();

	t.BuildFullModel();

	return 0;
}

void  Process_Options (int argc, char * argv []){
//  Get options and parameters from command line.  

   int  errflg = FALSE;
   int  ch;
   char  * p, * q;

   optarg = NULL;

   while(! errflg && ((ch = getopt (argc, argv, "k:rl:")) != EOF)){
     switch(ch){
        case 'k':    // model depth
           Model_Depth= int (strtol (optarg, & p, 10));
          if  (p == optarg || Model_Depth <= 0 || Model_Depth >20){
               cerr<<"Bad model depth value" << optarg<<endl;
               errflg = TRUE;
          }	
          break;
	case 'r':   // include model reverse complement 
	  Reverse_Complement =true;
	  break;
	case 'l':
	  lambda = strtod(optarg, &p);
	  if(lambda <=0 || lambda>1){
		cerr<<"\nlambda should be between 0 and 1"<<endl;
		exit(0);
	  }
	  break;
        case '?':
          fprintf (stderr, "Unrecognized option -%c\n", optopt);
        default :
          errflg = TRUE;
     }
   }
   if(errflg || optind != argc){
        Usage (argv[0]);
        exit (EXIT_FAILURE);
   }
   return;
}


static void  Usage (char * command){
//  Print the description of options and command line for this program. 

   fprintf (stderr,
       "\nUSAGE:  %s [options] \n\n"
       "Read sequences from standard input and build an Interpolated\n"
       "Markov Model (IMM) for them\n\n"
       "Options:\n"
       " -k <num>\n"
       "    Set the depth of model to <num>\n"
       " -r \n"
       "    Add reverse complement to the model\n"
       " -l <double>\n"
       "    for fixed lambda interpolation enter a value between 0 and 1\n"
       ,command);

   return;
}
