#!/usr/bin/perl

use strict;
use FindBin qw($Bin);
use Getopt::Long;
my $k_size   = 6; ## kmer_size
my $do_rc    = 1; ## turn on looking at reverse complements
my $w_dist   = 1; ##  word distribution

GetOptions ("k_size=i" => \$k_size,
	    "rc=i" => \$do_rc,
	    "w_dist=i" => \$w_dist);


my $target_fa    = $ARGV[0]; # testdata/target.fa 
my $outdir       = $ARGV[1]; # outdir
my $windowlength = $ARGV[2]; # 500;
my $shiftlength  = $ARGV[3]; # 50;

mkdir($outdir);

open(IN,"<$target_fa") or die "could not open $target_fa : $_";
while(my $line=<IN>){
        chomp($line);
        if($line =~ /^>/){
                my $hdr = "dummy";
                ($hdr) = split(/\s+/,$line);
                $hdr =~ s/>//g;
                my $seq = "";
                while(my $l2=<IN>){
                        if($l2 !~ /^>/){
                                chomp($l2);
                                $seq .= $l2;
                        }else{
                                seek(IN, -length($l2), 1);
                                last;
                        }
                }
                my $len = length($seq);
		my $lenbar = $len - $windowlength +1;	
		open(OUT2, ">$outdir/tmp_target");
		## slide a window
		my $start = 0;
		my $countwindows = 1;
		while ($start < $lenbar) {
		    my $subseq = substr($seq, $start, $windowlength);
		    print OUT2 ">$start\n";
		    print OUT2 "$subseq\n";

		    $start += $shiftlength;
		    $countwindows++;
		}
		close(OUT2);
		if($w_dist){
			system("$Bin/kworddistr.pl -rc $do_rc $outdir/tmp_target $k_size");
		}
        }else{
                next;
        }
}
close(IN);

